]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- syntax
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
19                 gettextize --copy --force --no-changelog; \
20         else \
21                 gettextize --copy --force --no-changelog --intl; \
22         fi; \
23         if [ ! -f po/Makevars ]; then \
24                 cp -f po/Makevars{.template,}; \
25         fi; \
26 }
27
28 %__glib_gettextize      glib-gettextize --copy --force
29 %__gnome_doc_common     gnome-doc-common --copy
30 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
31 %__gtkdocize            gtkdocize --copy
32 %__intltoolize          intltoolize --copy --force
33 %__libtoolize           libtoolize --copy --force
34
35 #       The number of cvs changelog entries kept when building package.
36 %_buildchangelogtruncate 20
37
38 %dependencytracking     %{nil}
39
40 #       Relations between package names that cause dependency loops
41 #       with legacy packages that cannot be fixed. Relations are
42 #       specified as
43 #               p>q
44 #       where package p has a Requires: on something that package q Provides:
45 #
46 # XXX   Note: that there cannot be any whitespace within the string "p>q",
47 #       and that both p and q are package names (i.e. no version/release).
48 %_dependency_whiteout   %{nil}
49
50 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
51         && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
52         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
53
54 #-----------------------------------------------------------------
55 #
56 # (re)definition of %{rpm*flags} with %filterout_* support
57 # BuildRequires:        awk
58 # BuildRequires:        rpmbuild(macros) >= 1.315
59 #
60 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
61 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
62 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
63 # %rpmldflags   = %optldflags - %filterout_ld
64 #
65 # Regular expressions are supported, but to avoid some character be treated
66 # as regular expression it must be escaped twice.
67
68 %filter_out                                             \
69         for (i = 1; i in I; i++) {      A=0;    \
70                 for (f in F) {                          \
71                         if (I[i] ~ "^" F[f] "$") A=1;   \
72                 };                                                      \
73                 if (!A) printf(I[i] FS);        \
74         }
75
76 %rpmcflags %(awk 'BEGIN {
77         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
78         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
79         %{filter_out}
80 }')
81
82 %rpmcxxflags %(awk 'BEGIN {
83         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
84         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
85         %{filter_out}
86 }')
87
88 %rpmldflags %(awk 'BEGIN {
89         split("%{?optldflags}",I);
90         split("%{?filterout_ld}",F)
91         %{filter_out}
92 }')
93
94 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
95 # but, don't use it, better use gcc as linker
96 %ld_rpmldflags %(awk 'BEGIN {
97         split("%{rpmldflags}",F);
98         for (f in F) {
99                 s = F[f];
100                 if (s ~ /^-Wl,/) {
101                         s = substr(s,5);
102                         gsub(/,/," ",s);
103                 };
104                 printf(s FS);
105         };
106 }')
107
108 #-----------------------------------------------------------------
109 %configure2_13 { \
110  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
111  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
112  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
113  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
114  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
115  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
116  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
117  %{?__cc:CC="%{__cc}" ; export CC ; } \
118  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
119  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
120         --host=%{_target_platform} \
121         --prefix=%{_prefix} \
122         --exec-prefix=%{_exec_prefix} \
123         --bindir=%{_bindir} \
124         --sbindir=%{_sbindir} \
125         --sysconfdir=%{_sysconfdir} \
126         --datadir=%{_datadir} \
127         --includedir=%{_includedir} \
128         --libdir=%{_libdir} \
129         --libexecdir=%{_libexecdir} \
130         --localstatedir=%{_localstatedir} \
131         --sharedstatedir=%{_sharedstatedir} \
132         --mandir=%{_mandir} \
133         --infodir=%{_infodir} \
134         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
135         %{dependencytracking} \
136 }
137
138 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
139 %__cmake        /usr/bin/cmake
140 %cmake { \
141 CC="%{__cc}" \
142 CXX="%{__cxx}" \
143 CFLAGS="%{rpmcflags}" \
144 CXXFLAGS="%{rpmcxxflags}" \
145 %{__cmake} \
146 }
147
148 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
149 %__scons        /usr/bin/scons
150 %scons { \
151 %{__scons} \
152         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
153         CFLAGS="${CFLAGS:-%rpmcflags}" \
154         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
155         FFLAGS="${FFLAGS:-%rpmcflags}" \
156         CPPFLAGS="${CPPFLAGS:-}" \
157         %{?__cc:CC="%{__cc}"} \
158         %{?__cxx:CXX="%{__cxx}"} \
159         libsuffix=%{_lib} \
160         prefix=%{_prefix} \
161 }
162
163 # waf. see waf.spec
164 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
165 %__waf  /usr/bin/waf
166 %waf { \
167 CC="%{__cc}" \
168 CXX="%{__cxx}" \
169 CPP="%{__cpp}" \
170 CFLAGS="%{rpmcflags}" \
171 CXXFLAGS="%{rpmcxxflags}" \
172 %{__waf} \
173 }
174
175 #----------------------------------------------------------------
176 %global configure_cache 0
177 %configure_cache_file   %{buildroot}.configure.cache
178
179 %configure {./configure \
180         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
181         CFLAGS="${CFLAGS:-%rpmcflags}" \
182         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
183         FFLAGS="${FFLAGS:-%rpmcflags}" \
184         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
185         CPPFLAGS="${CPPFLAGS:-}" \
186         %{?__cc:CC="%{__cc}"} \
187         %{?__cxx:CXX="%{__cxx}"} \
188         --host=%{_target_platform} \
189         --build=%{_target_platform} \
190         --prefix=%{_prefix} \
191         --exec-prefix=%{_exec_prefix} \
192         --bindir=%{_bindir} \
193         --sbindir=%{_sbindir} \
194         --sysconfdir=%{_sysconfdir} \
195         --datadir=%{_datadir} \
196         --includedir=%{_includedir} \
197         --libdir=%{_libdir} \
198         --libexecdir=%{_libexecdir} \
199         --localstatedir=%{_localstatedir} \
200         --sharedstatedir=%{_sharedstatedir} \
201         --mandir=%{_mandir} \
202         --infodir=%{_infodir} \
203         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
204         %{dependencytracking} \
205         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
206 }
207
208 # ------------------------------------------------------------------------
209 # Overloading of some basic macros
210 %prep \
211 %%prep\
212 export LC_ALL=C\
213 export LANG=C\
214 unset LINGUAS ||:\
215 unset LANGUAGE ||:\
216 unset LC_MESSAGES ||:\
217 unset DISPLAY ||:\
218 %{nil}
219
220 %build %%build\
221 export LC_ALL=C\
222 export LANG=C\
223 unset LINGUAS ||:\
224 unset LANGUAGE ||:\
225 unset LC_MESSAGES ||:\
226 unset DISPLAY ||:\
227 %{nil}
228
229 %install \
230 %if 0%{?_enable_debug_packages}\
231 %{?buildsubdir:%{debug_package}}\
232 %endif\
233 %%install\
234 export LC_ALL=C\
235 export LANG=C\
236 unset LINGUAS ||:\
237 unset LANGUAGE ||:\
238 unset LC_MESSAGES ||:\
239 unset DISPLAY ||:\
240 %{nil}
241
242 # Location of autoconf macros
243 %_aclocaldir    %(aclocal --print-ac-dir)
244
245 # Location of omf files
246 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
247
248 # Location of pkgconfig files
249 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
250
251 # Location of desktop files
252 %_desktopdir    /usr/share/applications
253 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
254
255 # Location of pixmaps for applnk/desktop files
256 %_pixmapsdir    /usr/share/pixmaps
257
258 # Location of themable icons for applnk/desktop files
259 %_iconsdir      /usr/share/icons
260
261 # Location of fonts directories
262 %_fontsdir      /usr/share/fonts
263
264 # Location of Gtk and associated libraries documentation
265 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
266
267 # Location of KDE documentation
268 %_kdedocdir     %{_defaultdocdir}/kde/HTML
269
270 # unsermake script
271 %__unsermake /usr/share/unsermake/unsermake
272
273 # Current date
274 %date           %(LC_ALL="C" date +"%a %b %d %Y")
275
276 # tmp directory
277 %tmpdir         %(echo "${TMPDIR:-/tmp}")
278
279 # Example files, programs, scripts...
280 %_examplesdir   /usr/src/examples
281
282 # Alternative kernel type/version
283 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
284
285 # The directory holding Linux kernel sources
286 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
287
288 # If non-empty "debug" macro defined, add "dbg" suffix to release number
289 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
290
291 # Requires name = version-release
292 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
293
294 %releq_kernel()                 %((LC_ALL="C" rpm -qf --qf '%%{name} = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
295 %releq_kernel_up()              %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
296 %releq_kernel_smp()             %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
297 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
298 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
299 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
300
301 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
302 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
303
304 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
305
306 # kernel version-release handling
307 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
308 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
309 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
310 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
311 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
312
313 # sgml macros
314 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
315 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
316 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
317 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
318 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
319 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
320 %docbook_sgmlcat_fix() { for l in \
321 '' \
322 '  -- default decl --' \
323 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
324 '  -- hacks for opensp --' \
325 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
326 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
327 '' \
328 ; do echo $l; done >> %1 \
329 }
330
331 # vim - "
332
333 # minimum file size needed for compressed documents.
334 # just smaller files than this get larger when compressed.
335 # some stats:
336 # - 0 byte file compressed was 25 bytes .gz
337 # - 39 byte file was compressed as 57
338 # - with test/test.spec@man 158 byte file was compressed also 158
339 %_min_compress_bytes    159
340
341 #-----------------------------------------------------------------
342 # find and gzip all files in %{_mandir} and %{infodir}
343 #
344 # Requires: xargs, find
345 #
346 #%no_install_post_compress_docs 1
347 %__spec_install_post_compress_docs { \
348 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
349         for i in /usr/share/man /usr/X11R6/man; do \
350                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
351                         echo "Compress man pages: $i"; \
352                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
353                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
354                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
355                                 m=$(readlink $a); \
356                                 rm -f $a; \
357                                 echo .so ${m##*/} > $a; \
358                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
359                         done; \
360                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
361                 fi; \
362         done; \
363         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
364                 echo "Compress info pages: %{_infodir}"; \
365                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
366                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
367                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
368         fi; \
369 }; __spec_install_post_compress_docs } }
370
371 #-----------------------------------------------------------------
372 # Strip executable binaries and shared object files
373 #
374 # Requires: find, awk, strip, cut, xargs
375 #
376 #%no_install_post_strip 1
377 %__spec_install_post_strip {%{!?debug: \
378 %{!?no_install_post_strip:__spec_install_post_strip() { \
379 if [ -d "$RPM_BUILD_ROOT" ]; then \
380         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
381                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
382                 modulecount=$(echo -n "$modulelist" | wc -l); \
383                 if [ "$modulecount" -gt 0 ]; then \
384                         printf "Stripping %d kernel modules..."; \
385                         echo "$modulelist" | xargs -l512 chmod u+w; \
386                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
387                         echo "DONE"; \
388                 fi; \
389         fi; \
390         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}`; \
391         if [ -n "$filelist" ]; then \
392                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
393                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
394                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
395                 archiveslist=`echo "$filetypes" | awk -F '/current ar archive/ {print $1}'`; \
396                 if [ -n "$elfexelist" ]; then \
397                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
398                         chmod u+w $elfexelist; \
399                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
400                         echo "DONE"; \
401                 fi; \
402                 if [ -n "$elfsharedlist" ]; then \
403                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
404                         chmod u+w $elfsharedlist; \
405                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
406                         echo "DONE"; \
407                 fi; \
408                 if [ -n "$archiveslist" ]; then \
409                         printf "Stripping %d ar archives..." $(echo "$elfsharedlist" | wc -l); \
410                         chmod u+w $archiveslist; \
411                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
412                         echo "DONE"; \
413                 fi; \
414         fi; \
415     filelist_all=%{?_autostripall:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}"`}; \
416     filelist_unneeded=%{?_autostripunneeded:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}"`}; \
417     filelist_debug=%{?_autostripdebug:`find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}"`}; \
418         if [ -n "$filelist_all" ]; then \
419                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
420                 chmod u+w $elfexelist; \
421                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
422                 echo "DONE"; \
423         fi; \
424         if [ -n "$filelist_unneeded" ]; then \
425                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
426                 chmod u+w $elfsharedlist; \
427                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
428                 echo "DONE"; \
429         fi; \
430         if [ -n "$filelist_debug" ]; then \
431                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
432                 chmod u+w $archiveslist; \
433                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
434                 echo "DONE"; \
435         fi; \
436 fi; }; __spec_install_post_strip } } }
437
438 #-----------------------------------------------------------------
439 # remove all RPATH from executable binaries and shared object files
440 #
441 # Requires: find, awk, cut, xargs, chrpath, uname
442 #
443 #%no_install_post_chrpath       1
444 %__spec_install_post_chrpath {%{!?debug: \
445 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
446 if [ -d "$RPM_BUILD_ROOT" ]; then \
447         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*"  %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
448         if [ -n "$files" ]; then \
449                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
450         fi
451         #"
452         if [ -n "$objs" ]; then \
453                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
454                 echo "$objs" | \
455                 while read file; do \
456                         rpath= ; \
457                         chmod u+w "$file"; \
458                         for dir in `chrpath -l "$file" | \
459                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
460                                         case $dir in \
461                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
462                                                 echo "remove-rpath: $dir in $file"; \
463                                                 ;; \
464                                         * ) \
465                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
466                                                 else rpath="$rpath:$dir" ; fi ; \
467                                                 ;; \
468                                         esac ; \
469                         done ; \
470                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
471                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
472                 done; \
473         fi; \
474 fi; }; __spec_install_post_chrpath } } }
475
476 #-----------------------------------------------------------------
477 # Find and gzip all kernel modules
478 #
479 # Requires: find
480 #
481 #%no_install_post_compress_modules      1
482 %__spec_install_post_compress_modules { \
483 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
484         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
485                 echo "Compress kernel modules"; \
486                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
487                 echo "$q" | xargs -r %{__gzip} -9nf; \
488                 printf "%d modules compressed\n" $(echo "$q" | wc -l); \
489                 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
490                 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
491         fi; \
492 }; __spec_install_post_compress_modules } }
493
494 # Remove common Perl files we don't package
495 %__spec_install_post_perl_clean {\
496 %{!?no_install_post_perl_clean: \
497 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
498 } }
499
500 #-----------------------------------------------------------------
501 # Update GConf2 schemas
502 #
503 # Requires: GConf2
504 #
505 %gconf_schema_install() \
506         umask 022; \
507         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
508         %{nil}
509
510 %gconf_schema_uninstall() \
511 if [ $1 = 0 ]; then \
512         umask 022; \
513         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
514 fi \
515 %{nil}
516
517 #-----------------------------------------------------------------
518 # Update desktop MIME database
519 # requires: desktop-file-utils
520 #
521 %update_desktop_database_post() {{ \
522         umask 022; \
523         /usr/bin/update-desktop-database -q; \
524 }} \
525 %{nil}
526
527 %update_desktop_database_postun() {{ \
528 if [ $1 = 0 ]; then \
529         umask 022; \
530         /usr/bin/update-desktop-database -q; \
531 fi \
532 }} \
533 %{nil}
534
535 #-----------------------------------------------------------------
536 # Update shared MIME info database
537 # requires: shared-mime-info
538 #
539 %update_mime_database() {{ \
540         umask 022; \
541         /usr/bin/update-mime-database %{_datadir}/mime; \
542 }} \
543 %{nil}
544
545 #-----------------------------------------------------------------
546 # Update icon cache
547 # requires: gtk+
548 #
549 %update_icon_cache() {{ \
550         umask 022; \
551         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
552 }} \
553 %{nil}
554
555 #-----------------------------------------------------------------
556 # Update scrollkeeper database
557 # requires: scrollkeeper
558 #
559 %scrollkeeper_update_post() \
560         /usr/bin/scrollkeeper-update -q; \
561         %{nil}
562
563 %scrollkeeper_update_postun() \
564 if [ $1 = 0 ]; then \
565         /usr/bin/scrollkeeper-update -q; \
566 fi \
567 %{nil}
568
569 #-----------------------------------------------------------------
570 # post %install sequence:
571 # - autodeps exceptions
572 # - compress all man and info pages,
573 # - strip all ELF executables and ELF shared objects if not %debug.
574 # - compress kernel modules if any
575
576 ###################################################################
577 # Requires/Provides automation
578 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
579 #
580 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
581 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
582 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
583 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
584 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
585 #%_noautocompressdoc    %{nil}
586 #
587 %_missing_doc_files_terminate_build     1%{nil}
588 %_unpackaged_files_terminate_build      %{nil}
589 # (X)emacs support
590 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
591 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
592 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
593
594 %__php_provides %{nil}
595 %__php_requires %{nil}
596 %__perl_provides %{nil}
597 %__perl_requires %{nil}
598 %__mono_provides %{nil}
599 %__mono_requires %{nil}
600
601 # Perl specific macro definitions.
602 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
603 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
604 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
605 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
606 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
607 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
608
609 # Ruby
610 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
611 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
612 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
613 %ruby_vendorarchdir     %(ruby -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)
614 %ruby_vendorlibdir      %(ruby -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)
615 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
616 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
617 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
618 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
619 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
620
621 %php_pear_dir           /usr/share/pear
622 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
623 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
624 %php_includedir         %(php-config --include-dir 2>/dev/null || echo ERROR)
625
626 # extract php/zend api versions
627 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
628 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)
629 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
630 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
631 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
632 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
633 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})
634
635 # helper macro
636 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
637
638 # macros for public use
639 # for php extensions (php-pecl)
640 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
641 %{__php_api_requires zend_module_api} \
642 %{__php_api_requires -v %php_major_version debug php_debug} \
643 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
644
645 # for zend extensions
646 %requires_zend_extension %{__php_api_requires zend_module_api} \
647 %{__php_api_requires zend_extension_api} \
648 %{__php_api_requires -v %php_major_version debug php_debug} \
649 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
650
651 # for php pdo modules (php-pecl-PDO_*)
652 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
653
654 # for using PHP post scripts. for PHP >= 5.0
655 %php_webserver_restart \
656 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
657 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
658 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
659         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
660         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
661                 %service -q php-fcgi restart \
662         fi \
663 fi \
664 %{nil}
665
666 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
667 %php4_webserver_restart \
668 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
669 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
670 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
671         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
672         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
673                 %service -q php-fcgi restart \
674         fi \
675 fi \
676 %{nil}
677
678
679 # X.org helper macros
680 %__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
681 #
682 %xorg_xserver_ansic_abi         %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
683 %xorg_xserver_extension_abi     %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
684 %xorg_xserver_font_abi          %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)
685 %xorg_xserver_videodrv_abi      %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
686 %xorg_xserver_xinput_abi        %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
687
688 %requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
689 %{__xorg_abi_requires extension xorg_xserver_extension_abi}
690 %requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
691 %{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
692 %requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
693 %{__xorg_abi_requires font xorg_xserver_font_abi}
694 %requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
695 %{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
696
697 # Python specific macro definitions.
698 # python main version
699 %py_ver                 %(python -c "import sys; print sys.version[:3]")
700
701 # directories
702 %py_prefix              %(python -c "import sys; print sys.prefix")
703 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
704 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
705 %py_incdir              /usr/include/python%{py_ver}
706 %py_sitedir             %{py_libdir}/site-packages
707 %py_sitescriptdir %{py_scriptdir}/site-packages
708 %py_dyndir              %{py_libdir}/lib-dynload
709
710 # pure python modules compilation
711 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
712
713 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
714
715 # Software written in Python language require Python with main version
716 %pyrequires_eq() Requires:      %1
717
718 # Hardlink binary identical .pyc and .pyo files
719 # (idea by glen <at> pld-linux <dot> org)
720 %__spec_install_post_py_hardlink {\
721 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
722 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
723         b="${a%.pyc}.pyo"; \
724         if cmp -s "$a" "$b"; then \
725                 ln -f "$a" "$b"; \
726         fi; \
727 done \
728 }; __spec_install_post_py_hardlink } }
729
730 # remove python sources, so that check-files won't complain
731 # (idea by glen <at> pld-linux <dot> org)
732 %py_postclean() \
733 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
734  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
735 done \
736 %{nil}
737
738 # depmod macro
739 %depmod() { \
740 umask 022; \
741 if [ -e /boot/System.map-%1 ]; then \
742         /sbin/depmod -a -F /boot/System.map-%1 %1; \
743 else \
744         if [ -e /boot/System.map ]; then \
745                 /sbin/depmod -a -F /boot/System.map %1; \
746         else \
747                 /sbin/depmod -a %1; \
748         fi \
749 fi; \
750 }
751
752 # XMMS specific macros
753 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
754 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
755 %xmms_version                   %(xmms-config --version 2>/dev/null)
756 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
757 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
758 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
759 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
760 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
761 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
762 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
763
764 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
765
766 # user/group checking macros
767 #
768 # Usage:
769 #       %userremove myuser
770 #
771 %userremove     /usr/lib/rpm/user_group.sh user del
772 %groupremove    /usr/lib/rpm/user_group.sh group del
773 #
774 # Usage:
775 #       if %usertestrm myuser; then
776 #               /usr/sbin/userdel -r myuser
777 # Note:
778 #       use these macros only if you need to call userdel/groupdel with
779 #       a non-standard option or take an extra action; otherwise use the
780 #       %userremove/%groupremove macros
781 #
782 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
783 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
784 # user group membership management macros
785 #
786 # Usage:
787 #       %addusertogroup myuser agroup
788 #
789 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
790
791 # banner support (useful in {pre,post}{,un} and triggers)
792 #
793 # Usage:
794 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
795 # the banner text, the banner text
796 # the banner text, and following line
797 #EOF
798 # You can use any form of here-document, <<'EOF' <<-EOT will do.
799 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
800 #
801 # -a   - append to the banner
802 # -e   - send to stderr instead of stdout
803 # -n   - no show banner (overrides -t)
804 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
805 %banner(aent:)  \
806 RPM_SCRIPTVERBOSITY=5 \
807 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
808 if [ -x /usr/bin/banner.sh ]; then \
809         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
810 else \
811         CMD="cat%{-e: >&2}" \
812 fi \
813 eval $CMD %2%{?3: %3} \
814 %nil
815
816 # useradd/groupadd macros
817 # Author: Elan Ruusamäe <glen@pld-linux.org>
818 #
819 # Usage:
820 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
821 #   [-g initial_group] [-G group[,...]] login
822 #
823 #  -u uid. REQUIRED
824 #  -g gid/group. REQUIRED
825 #  -s defaults to /bin/false
826 #  -d defaults to /usr/share/empty
827 #  -c No default
828 #  -r is accepted but ignored (it's always set)
829 #  -k skeleton dir. defaults to /usr/share/empty
830 # rpm specific flags
831 #  -P package name. defaults to %{name}
832 #
833 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
834 %{!-u:%{error:useradd: Required argument -u missing}} \
835 %{!-g:%{error:useradd: Required argument -g missing}} \
836 %{!?1:%{error:useradd: Required parameter login missing}} \
837 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
838         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
839                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
840                 exit 1 \
841         fi \
842 else \
843         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
844         /usr/sbin/useradd \\\
845                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
846                 -u %{-u*} \\\
847                 -r \\\
848                 -d %{-d*}%{!-d:/usr/share/empty} \\\
849                 -s %{-s*}%{!-s:/bin/false} \\\
850                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
851                 -g %{-g*} \\\
852                 %{-M} \\\
853                 %{-G:-G %{-G*}} \\\
854                 %{expand:%{%{#}}} 1>&2 || exit $? \
855         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
856 fi;
857
858 # Usage:
859 #   %groupadd [-P package] [-g gid] group
860 #
861 # -g gid. REQUIRED
862 #
863 # Sample:
864 #   %groupadd -P %{name}-base -g %{gid} %{name}
865
866 %groupadd(g:P:rfo)      \
867 %{!-g:%{error:groupadd: Required argument -g missing}} \
868 %{!?1:%{error:groupadd: Required parameter group missing}} \
869 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
870         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
871                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
872                 exit 1 \
873         fi \
874 else \
875         echo "Adding group %{1} GID=%{-g*}." \
876         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
877         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
878 fi;
879
880 # webapp macros
881 # Author: Elan Ruusamäe <glen@pld-linux.org>
882 #
883 # The config is installed/removed inside trigger, this means that you can any
884 # time install apache1/apache/lighttpd package and the configuration file is
885 # updated. if you don't need the config for various reason for specific
886 # webserver, just remove the symlink from config directory using webapp
887 # program. the trigger will not recreate the symlink on upgrades. In other
888 # words the config is linked to webserver config directory on first install of
889 # PACKAGE or WEBSERVER.
890 #
891 # Add package's webserver config to webserver webapps dir.
892 # Usage:
893 #   %webapp_register WEBSERVER WEBAPP
894 #
895 %webapp_register() \
896 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
897 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
898         /usr/sbin/webapp register %1 %2\
899 fi\
900 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
901 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
902         %{expand:%service -q %%1 reload}\
903 fi\
904 %{nil}
905
906 # Remove package's config from webserver webapps dir.
907 # Usage:
908 #   %webapp_register [-f] WEBSERVER WEBAPP
909 %webapp_unregister(f) \
910 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
911 # remove link if either of the packages are gone \
912 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
913         /usr/sbin/webapp unregister %1 %2\
914         %{expand:%service -q %%1 reload}\
915 fi \
916 %{nil}
917
918 # service macro.
919 # Author: Elan Ruusamäe <glen@pld-linux.org>
920 #
921 # calls usual service restart on package %post, but skips the restart if
922 # administrator has disabled automatic service restarts in either global
923 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
924 #
925 # Usage:
926 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
927 #
928 #  -q be silent when service isn't started (for scriplets restaring other package's services)
929 #
930 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
931
932
933 # Java macros. based on jpackage macros.java
934 #
935 # Root directory where all Java VMs/SDK/JREs are installed.
936 %_jvmdir                %{_libdir}/jvm
937
938 # Root directory where all Java VMs/SDK/JREs expose their jars
939 %_jvmjardir             %{_libdir}/jvm-exports
940
941 # Root directory for all Java VM/SDK/JRE's private things.
942 %_jvmprivdir    %{_libdir}/jvm-private
943
944 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
945 %_jvmlibdir             %{_libdir}/jvm
946
947 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
948 %_jvmdatadir    %{_datadir}/jvm
949
950 # Root directory for all configurations parts of Java VM/SDK/JRE's
951 %_jvmsysconfdir %{_sysconfdir}/jvm
952
953 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
954 %_jvmcommonlibdir       %{_libdir}/jvm-common
955
956 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
957 %_jvmcommondatadir      %{_datadir}/jvm-common
958
959 # Root directory for all common configurations parts of Java VM/SDK/JRE's
960 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
961
962 # Directory where arch-specific (JNI) version-independent jars are installed.
963 %_jnidir                %{_libdir}/java
964
965 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
966
967 %ant                    JAVA_HOME=%{java_home} ant
968 %jar                    %{java_home}/bin/jar
969 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
970 %javac                  %{java_home}/bin/javac
971 %javadoc                %{java_home}/bin/javadoc
972
973 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
974
975 %jpackage_script() \
976 install -d $RPM_BUILD_ROOT%{_bindir}\
977 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
978 #!/bin/sh\
979 #\
980 # %{name} script\
981 # JPackage Project <http://www.jpackage.org/>\
982 \
983 # Source functions library\
984 . %{_javadir}-utils/java-functions\
985 \
986 # Source system prefs\
987 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
988     . %{_sysconfdir}/java/%{name}.conf\
989 fi\
990 \
991 # Source user prefs\
992 if [ -f $HOME/.%{name}rc ]; then\
993     . $HOME/.%{name}rc\
994 fi\
995 \
996 # Configuration\
997 MAIN_CLASS=%1\
998 BASE_FLAGS=%2\
999 BASE_OPTIONS=%3\
1000 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1001 \
1002 # Set parameters\
1003 set_jvm\
1004 set_classpath $BASE_JARS\
1005 set_flags $BASE_FLAGS\
1006 set_options $BASE_OPTIONS\
1007 \
1008 # Let's start\
1009 run "$@"\
1010 EOF
1011
1012 # jpackage 1.7
1013 # Directory for maven depmaps
1014 #
1015 %_mavendepmapdir /etc/maven
1016 %_mavendepmapfragdir /etc/maven/fragments
1017
1018 #
1019 # add_to_depmap adds an entry to the depmap. The arguments are:
1020 #
1021 # %1 the original groupid
1022 # %2 the original artifact id
1023 # %3 the version
1024 # %4 the new groupid
1025 # %5 the new artifactid
1026 #
1027
1028 %add_to_maven_depmap() \
1029 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1030 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1031 <dependency>\
1032     <maven>\
1033         <groupId>%1</groupId>\
1034         <artifactId>%2</artifactId>\
1035         <version>%3</version>\
1036     </maven>\
1037     <jpp>\
1038         <groupId>%4</groupId>\
1039         <artifactId>%5</artifactId>\
1040         <version>%3</version>\
1041     </jpp>\
1042 </dependency>\
1043 \
1044 EOF\
1045 %{nil}
1046
1047 #==============================================================================
1048 #
1049 # update_maven_depmap updates the main maven depmap
1050 #
1051 %update_maven_depmap() \
1052 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1053 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1054 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1055 fi\
1056 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1057
1058
1059 # PEAR install macros
1060 # Author: Elan Ruusamäe <glen@pld-linux.org>
1061 #
1062 # Usage:
1063 #       %%pear_package_setup [-a #] [-n FMT]
1064 #
1065 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1066 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1067 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1068 #
1069 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1070 # destination hierarchy. you should copy the tree to buildroot after
1071 # patching/reorganizing with %%pear_package_install.
1072 #
1073 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1074 # line endings.
1075 #
1076 # the pear install process output is recorded to install.log, you should put it
1077 # to %%doc for later debug or just for information.
1078 #
1079 # additionally additional-packages.txt is produced if it was detected that the
1080 # package has optional dependencies. the file format is suitable of displaying
1081 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1082 # automatically added for this file.
1083
1084
1085 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1086 %__pear_install_log \
1087 tee install.log \
1088 # make post message of optional packages \
1089 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1090 if [ -s optional-packages.txt ]; then \
1091         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1092 else \
1093         rm -f optional-packages.txt \
1094 fi \
1095 %{nil}
1096
1097 # command invoking pear cli
1098 %__pear /usr/bin/pear
1099
1100 %pear_install(a:n:zD) \
1101 %__pear \\\
1102         -c pearrc \\\
1103         -d doc_dir=/docs \\\
1104         -d php_dir=%{php_pear_dir} \\\
1105         -d bin_dir=%{_bindir} \\\
1106         -d data_dir=%{php_pear_dir}/data \\\
1107         -d test_dir=%{php_pear_dir}/tests \\\
1108         install \\\
1109         --packagingroot=%{builddir} \\\
1110         --offline \\\
1111         --nodeps \\\
1112         %{-f:--force} \\\
1113         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1114 %{nil}
1115
1116 # The main macro.
1117 # using this macro will append optional-packages.txt to the nocompressdoc list
1118 # as it's displayed to user after package install. and adding additional gzip
1119 # dep is just waste ;)
1120 %pear_package_setup(a:n:zD) \
1121 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1122 %define builddir %{_builddir}/%{srcdir} \
1123 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1124 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1125 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1126 %pear_install \
1127 %{-z:cd ..} \
1128 cat %{-z:$_N/}.install.log | %__pear_install_log \
1129 \
1130 # undos sources \
1131 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1132 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1133 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1134 %{nil}
1135
1136 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1137 # Author: Elan Ruusamäe <glen@pld-linux.org>
1138 %pear_package_install() \
1139 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1140 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1141 # help the developer out a little: \
1142 if [ -f _noautoreq ]; then \
1143         echo "AutoReqdep detected:" \
1144         echo "_noautoreq $(cat _noautoreq)" \
1145 fi \
1146 %{nil}
1147
1148
1149 # Register OpenLDAP schema.
1150 # Author: Elan Ruusamäe <glen@pld-linux.org>
1151 #
1152 # Usage:
1153 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1154 #
1155 #  -d specify dependant schemas, separated by comma
1156 #
1157 %openldap_schema_register(d:) \
1158 for schema in %*; do \
1159         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1160                 %{__sed} -i -e " \
1161                         /^include.*local.schema/{ \
1162                                 iinclude\\t     $schema\
1163                         } \
1164                 " /etc/openldap/slapd.conf \
1165         fi \
1166 done \
1167 # enable dependant schemas \
1168 if [ "%{-d*}" ]; then \
1169         %{__sed} -i -e ' \
1170         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1171                 s/^#// \
1172         }' /etc/openldap/slapd.conf \
1173 fi \
1174 %{nil}
1175
1176 # Unregister OpenLDAP schema.
1177 # Author: Elan Ruusamäe <glen@pld-linux.org>
1178 #
1179 # Usage:
1180 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1181 #
1182 %openldap_schema_unregister() \
1183 for schema in %*; do \
1184         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1185                 %{__sed} -i -e " \
1186                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1187                 # for symmetry it would be nice if we disable enabled schemas in post, \
1188                 # but we really can not do that, it would break something else. \
1189                 " /etc/openldap/slapd.conf \
1190         fi \
1191 done \
1192 %{nil}
1193
1194 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1195
1196
1197 # Build modules for kernels 2.6
1198 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1199 #
1200 # Usage:
1201 #       %build_kernel_modules -m <modules> -C <directory>
1202 #
1203 #  remember that proper Makefile is still required
1204 # Options:
1205 #  -m <modules> (required) -- comma-separated list of modules to save,
1206 #               without .ko extension, may be placed in subdirectory
1207 #  -C <directory> -- change to <directory> before doing anything
1208 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1209 #  -c -- do not execute make clean
1210 #  <additional arguments> -- all additional arguments will be passed to
1211 #               make modules
1212 #
1213 # Additional patching supported via here document. Try:
1214 #       %build_kernel_modules -m module <<'EOF'
1215 #       your patch script here
1216 #       EOF
1217 # Don't use it unless patching depends on config options.
1218
1219 # Developer note: don't touch it unless you know how to handle '\'.
1220 # - \ in script expands to nothing
1221 # - \\\ in script expands to \
1222 # - \\\ inside definition expands to nothing
1223 # - \\\\\\\ inside definition expands to \
1224 # - in last line \ has to touch arguments so arguments passing
1225 #   in new lines (using \) will be supported
1226
1227 %build_kernel_modules(p:P:m:C:c)                                                                        \
1228 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1229                                                                                                                                         \
1230 %define Opts                                                                                                            \\\\\\\
1231 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1232         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1233         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1234         %else                                                                                                                   \\\
1235         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1236         %endif                                                                                                                  \\\
1237 %else                                                                                                                           \\\
1238         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1239 %endif                                                                                                                          \
1240 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1241                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1242                                                                                                                                         \
1243 %{?-C:cd %{-C*}}                                                                                                        \
1244 compile() {                                                                                                                     \
1245         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1246         set -e -x                                                                                                               \
1247         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1248                                                                                                                                         \
1249 for cfg in ${cfgs:-dist}; do                                        \
1250         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1251                                                                                                                                         \
1252         rm -rf o                                                                                                                \
1253         install -d o/include/linux                                                                              \
1254         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1255         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1256         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1257 %ifarch ppc ppc64                                                                                                       \
1258         install -d o/include/asm                                                                                \
1259         [ ! -d %{_kernelsrcdir}/include/asm-%{_target_base_arch} ] || ln -snf %{_kernelsrcdir}/include/asm-%{_target_base_arch}/* o/include/asm \
1260         [ ! -d %{_kernelsrcdir}/include/asm-powerpc ] || ln -snf %{_kernelsrcdir}/include/asm-powerpc/* o/include/asm \
1261 %else                                                                                                                           \
1262         ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} o/include/asm \
1263 %endif                                                                                                                          \
1264                                                                                                                                         \
1265         set +x                                                                                                                  \
1266         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1267         set -x                                                                                                                  \
1268                                                                                                                                         \
1269         %if %{with dist_kernel}                                                                                 \
1270                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1271                         %{-p*} %{-P*}                                                                                   \\\
1272                         %{MakeOpts}                                                                                             \
1273         %else                                                                                                                   \
1274                 install -d o/include/config                                                                     \
1275                 touch o/include/config/MARKER                                                           \
1276                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1277         %endif                                                                                                                  \
1278                                                                                                                                         \
1279         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1280                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1281                 M=$PWD %{MakeOpts}}                                                                                     \
1282         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1283                 ${1+"$@"}                                                                                                       \\\
1284                 M=$PWD %{MakeOpts}                                                                                      \
1285                                                                                                                                         \
1286         for MODULE in {%{-m*},}; do                                                                             \
1287                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1288         done                                                                                                                    \
1289 done                                                                                                                            \
1290 %{?-C:cd -}                                                                                                                     \
1291 }                                                                                                                                       \
1292 compile %{*}\
1293 %{nil}
1294
1295
1296 # Install kernel modules built by %build_kernel_modules
1297 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1298 #
1299 # Usage:
1300 #       %install_kernel_modules -m <modules> -d <directory>
1301 #
1302 # Options:
1303 #  -m <modules> (required) -- comma-separated list of modules to install,
1304 #               without .ko extension, may be placed in subdirectory
1305 #  -d <directory> (required) -- in what subdirectory modules should be
1306 #               installed (eg. misc, kernel/drivers/net)
1307 #  -s <suffix> -- suffix to use when installing modules, useful when module
1308 #               with same name exists in kernel already
1309 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1310 #               for defining aliases, only useful with -s
1311
1312 %install_kernel_modules(m:d:s:n:)                                                                       \
1313 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1314 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1315 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1316                                                                                                                                         \
1317 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1318 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1319                                                                                                                                         \
1320 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1321                                                                                                                                         \
1322 for MODULE in {%{-m*},}; do                                                                                     \
1323         [ -n "${MODULE}" ] || continue                                                                  \
1324         for cfg in ${cfgs:-dist}; do                                    \
1325                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1326                 MNAME=${MODULE##*/}                                                                                     \
1327                 install -D ${MODULE}-$cfg.ko                                                            \\\
1328                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1329                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1330                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1331                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1332         done                                                                                                                    \
1333 done                                                                                                                            \
1334 %{nil}
1335
1336 # patchset macros
1337 # Author: Elan Ruusamäe <glen@pld-linux.org>
1338 #
1339 # Usage:
1340 #   %patchset_source -f <seq(1) format> <start> [<end>]
1341 #   %patchset_patch <start> [<end>]
1342 #
1343 # If <end> is omited, it is assumed to be <start>.
1344 #
1345 # For example in preamble:
1346 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1347 # and in %prep:
1348 #  %patchset_patch 33 44
1349
1350 # generate SourceX urls from range START STOP
1351 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1352 # The sources start from 10000
1353 %patchset_source(f:b:) %(
1354         base=%{-b*}%{!-b*:10000};
1355         start=$(expr $base + %1);
1356         end=$(expr $base + %{?2}%{!?2:%{1}});
1357         # we need to call seq twice as it doesn't allow two formats
1358         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1359         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1360         paste %{tmpdir}/__ps{1,2};
1361         rm -f %{tmpdir}/__ps{1,2};
1362 ) \
1363 %{nil}
1364
1365 # apply sources from %patchset_source
1366 # -p specify -pX for %patch line
1367 # -b base offset: defaults to 10000
1368 %patchset_patch(f:p:b:) %(
1369         base=%{-b*}%{!-b*:10000};
1370         start=$(expr $base + %1);
1371         end=$(expr $base + %{?2}%{!?2:%{1}});
1372         echo ": patchset_patch %1%{?2: to %2}";
1373         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1374 ) \
1375 %{nil}
1376
1377 # browser plugins v2
1378 # Author: Elan Ruusamäe <glen@pld-linux.org>
1379 #
1380 # Usage:
1381 #       %browser_plugins_add_browser <name> -p <plugindir>
1382 #
1383 #  <name> (required) -- name of the browser. usually %{name}.
1384 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1385 #  -b -- default blacklists
1386 #  -a <arch> override arch
1387 #
1388 # Example:
1389 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1390
1391 %_browserpluginsconfdir         /etc/browser-plugins
1392 %_browserpluginsdir                     %{_libdir}/browser-plugins
1393 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1394
1395 %browser_plugins_add_browser(p:b:a:) \
1396         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1397         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1398         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1399         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1400         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1401         %{-b:cat >> $blacklist_file %{-b*}} \
1402 %{nil}
1403
1404 # vim:ts=4 sw=4 noet syn=spec
This page took 0.321792 seconds and 3 git commands to generate.